// This file was generated by gir (https://github.com/gtk-rs/gir)
// from
// from gir-files (https://github.com/gtk-rs/gir-files.git)
// DO NOT EDIT

use glib::{
    prelude::*,
    signal::{connect_raw, SignalHandlerId},
    translate::*,
};
use std::{boxed::Box as Box_, fmt, mem::transmute};

glib::wrapper! {
    #[doc(alias = "DzlSearchBar")]
    pub struct SearchBar(Object<ffi::DzlSearchBar, ffi::DzlSearchBarClass>) @extends gtk::Bin, gtk::Container, gtk::Widget, @implements gtk::Buildable;

    match fn {
        type_ => || ffi::dzl_search_bar_get_type(),
    }
}

impl SearchBar {
    pub const NONE: Option<&'static SearchBar> = None;

    #[doc(alias = "dzl_search_bar_new")]
    pub fn new() -> SearchBar {
        assert_initialized_main_thread!();
        unsafe { gtk::Widget::from_glib_none(ffi::dzl_search_bar_new()).unsafe_cast() }
    }
}

impl Default for SearchBar {
    fn default() -> Self {
        Self::new()
    }
}

mod sealed {
    pub trait Sealed {}
    impl<T: super::IsA<super::SearchBar>> Sealed for T {}
}

pub trait SearchBarExt: IsA<SearchBar> + sealed::Sealed + 'static {
    #[doc(alias = "dzl_search_bar_get_entry")]
    #[doc(alias = "get_entry")]
    fn entry(&self) -> Option<gtk::SearchEntry> {
        unsafe {
            from_glib_none(ffi::dzl_search_bar_get_entry(
                self.as_ref().to_glib_none().0,
            ))
        }
    }

    #[doc(alias = "dzl_search_bar_get_search_mode_enabled")]
    #[doc(alias = "get_search_mode_enabled")]
    fn is_search_mode_enabled(&self) -> bool {
        unsafe {
            from_glib(ffi::dzl_search_bar_get_search_mode_enabled(
                self.as_ref().to_glib_none().0,
            ))
        }
    }

    #[doc(alias = "dzl_search_bar_get_show_close_button")]
    #[doc(alias = "get_show_close_button")]
    fn shows_close_button(&self) -> bool {
        unsafe {
            from_glib(ffi::dzl_search_bar_get_show_close_button(
                self.as_ref().to_glib_none().0,
            ))
        }
    }

    #[doc(alias = "dzl_search_bar_set_search_mode_enabled")]
    fn set_search_mode_enabled(&self, search_mode_enabled: bool) {
        unsafe {
            ffi::dzl_search_bar_set_search_mode_enabled(
                self.as_ref().to_glib_none().0,
                search_mode_enabled.into_glib(),
            );
        }
    }

    #[doc(alias = "dzl_search_bar_set_show_close_button")]
    fn set_show_close_button(&self, show_close_button: bool) {
        unsafe {
            ffi::dzl_search_bar_set_show_close_button(
                self.as_ref().to_glib_none().0,
                show_close_button.into_glib(),
            );
        }
    }

    #[doc(alias = "activate")]
    fn connect_activate<F: Fn(&Self) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe extern "C" fn activate_trampoline<P: IsA<SearchBar>, F: Fn(&P) + 'static>(
            this: *mut ffi::DzlSearchBar,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(SearchBar::from_glib_borrow(this).unsafe_cast_ref())
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"activate\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    activate_trampoline::<Self, F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }

    fn emit_activate(&self) {
        self.emit_by_name::<()>("activate", &[]);
    }

    #[doc(alias = "reveal")]
    fn connect_reveal<F: Fn(&Self) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe extern "C" fn reveal_trampoline<P: IsA<SearchBar>, F: Fn(&P) + 'static>(
            this: *mut ffi::DzlSearchBar,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(SearchBar::from_glib_borrow(this).unsafe_cast_ref())
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"reveal\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    reveal_trampoline::<Self, F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }

    fn emit_reveal(&self) {
        self.emit_by_name::<()>("reveal", &[]);
    }

    #[doc(alias = "search-mode-enabled")]
    fn connect_search_mode_enabled_notify<F: Fn(&Self) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe extern "C" fn notify_search_mode_enabled_trampoline<
            P: IsA<SearchBar>,
            F: Fn(&P) + 'static,
        >(
            this: *mut ffi::DzlSearchBar,
            _param_spec: glib::ffi::gpointer,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(SearchBar::from_glib_borrow(this).unsafe_cast_ref())
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"notify::search-mode-enabled\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    notify_search_mode_enabled_trampoline::<Self, F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }

    #[doc(alias = "show-close-button")]
    fn connect_show_close_button_notify<F: Fn(&Self) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe extern "C" fn notify_show_close_button_trampoline<
            P: IsA<SearchBar>,
            F: Fn(&P) + 'static,
        >(
            this: *mut ffi::DzlSearchBar,
            _param_spec: glib::ffi::gpointer,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(SearchBar::from_glib_borrow(this).unsafe_cast_ref())
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"notify::show-close-button\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    notify_show_close_button_trampoline::<Self, F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }
}

impl<O: IsA<SearchBar>> SearchBarExt for O {}

impl fmt::Display for SearchBar {
    fn fmt(&self, f: &mut fmt::Formatter) -> fmt::Result {
        f.write_str("SearchBar")
    }
}
